Index: /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90
===================================================================
--- /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 2231)
+++ /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 2232)
@@ -814,118 +1529,193 @@
        IMPLICIT NONE
 
+
+       INTEGER(iwp)  ::  m       !< loop variable over all horizontal surf elements 
+
 ! 
-!--    Compute theta*
-       IF ( constant_heatflux )  THEN
-
+!--    Compute theta* at horizontal surfaces
+       IF ( constant_heatflux  .AND.  .NOT. surf_vertical )  THEN
 !
 !--       For a given heat flux in the surface layer:
-          !$OMP PARALLEL DO
-          DO  i = nxlg, nxrg
-             DO  j = nysg, nyng
-                k   = nzb_s_inner(j,i)
-                ts(j,i) = -shf(j,i) * drho_air_zw(k) / ( us(j,i) + 1E-30_wp )
-!
-!--             ts must be limited, because otherwise overflow may occur in case
-!--             of us=0 when computing ol further below
-                IF ( ts(j,i) < -1.05E5_wp )  ts(j,i) = -1.0E5_wp
-                IF ( ts(j,i) >   1.0E5_wp )  ts(j,i) =  1.0E5_wp
-             ENDDO
+
+          !$OMP PARALLEL DO PRIVATE( i, j, k )
+          DO  m = 1, surf%ns 
+
+             i   = surf%i(m)            
+             j   = surf%j(m)
+             k   = surf%k(m)
+
+             surf%ts(m) = -surf%shf(m) * drho_air_zw(k-1) /                    &
+                                  ( surf%us(m) + 1E-30_wp )
+
+!
+!--          ts must be limited, because otherwise overflow may occur in case
+!--          of us=0 when computing ol further below
+             IF ( surf%ts(m) < -1.05E5_wp )  surf%ts(m) = -1.0E5_wp
+             IF ( surf%ts(m) >  1.0E5_wp  )  surf%ts(m) =  1.0E5_wp
+
           ENDDO
 
-       ELSE
+       ELSEIF ( .NOT. surf_vertical ) THEN
 !
 !--       For a given surface temperature:
           IF ( large_scale_forcing  .AND.  lsf_surf )  THEN
-             !$OMP PARALLEL DO
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   k = nzb_s_inner(j,i)
-                   pt(k,j,i) = pt_surface
-                ENDDO
-             ENDDO
-          ENDIF
-
-          !$OMP PARALLEL DO PRIVATE( k, z_mo )
-          DO  i = nxlg, nxrg
-             DO  j = nysg, nyng
-
-                k   = nzb_s_inner(j,i)
-                z_mo = zu(k+1) - zw(k)
-
-                IF ( cloud_physics )  THEN
-                   ts(j,i) = kappa * ( pt1(j,i) - pt(k,j,i) )                  &
-                                     / ( LOG( z_mo / z0h(j,i) )                &
-                                         - psi_h( z_mo / ol(j,i) )             &
-                                         + psi_h( z0h(j,i) / ol(j,i) ) )
-                ELSE
-                   ts(j,i) = kappa * ( pt(k+1,j,i) - pt(k,j,i) )               &
-                                     / ( LOG( z_mo / z0h(j,i) )                &
-                                         - psi_h( z_mo / ol(j,i) )             &
-                                         + psi_h( z0h(j,i) / ol(j,i) ) )
-                ENDIF
-
-             ENDDO
+
+             !$OMP PARALLEL DO PRIVATE( i, j, k )
+             DO  m = 1, surf%ns 
+                i   = surf%i(m)            
+                j   = surf%j(m)
+                k   = surf%k(m)
+
+                pt(k-1,j,i) = pt_surface
+             ENDDO
+          ENDIF
+
+          IF ( cloud_physics )  THEN
+             !$OMP PARALLEL DO PRIVATE( i, j, k, z_mo )
+             DO  m = 1, surf%ns   
+
+                i   = surf%i(m)            
+                j   = surf%j(m)
+                k   = surf%k(m)
+
+                z_mo = surf%z_mo(m)
+
+                surf%ts(m) = kappa * ( surf%pt1(m) - pt(k-1,j,i) )             &
+                                     / ( LOG( z_mo / surf%z0h(m) )             &
+                                         - psi_h( z_mo / surf%ol(m) )          &
+                                         + psi_h( surf%z0h(m) / surf%ol(m) ) )
+
+             ENDDO
+          ELSE
+             !$OMP PARALLEL DO PRIVATE( i, j, k, z_mo )
+             DO  m = 1, surf%ns   
+
+                i   = surf%i(m)            
+                j   = surf%j(m)
+                k   = surf%k(m)
+
+                z_mo = surf%z_mo(m)
+
+                surf%ts(m) = kappa * ( pt(k,j,i) - pt(k-1,j,i) )               &
+                                     / ( LOG( z_mo / surf%z0h(m) )             &
+                                         - psi_h( z_mo / surf%ol(m) )          &
+                                         + psi_h( surf%z0h(m) / surf%ol(m) ) )
+             ENDDO
+          ENDIF
+       ENDIF
+! 
+!--    Compute theta* at vertical surfaces. This is only required in case of 
+!--    land-surface model, in order to compute aerodynamical resistance.
+       IF ( surf_vertical )  THEN
+          !$OMP PARALLEL DO PRIVATE( i, j, k )
+          DO  m = 1, surf%ns 
+
+             i          =  surf%i(m)            
+             j          =  surf%j(m)
+             k          =  surf%k(m)
+             surf%ts(m) = -surf%shf(m) / ( surf%us(m) + 1E-30_wp )
+!
+!--          ts must be limited, because otherwise overflow may occur in case
+!--          of us=0 when computing ol further below
+             IF ( surf%ts(m) < -1.05E5_wp )  surf%ts(m) = -1.0E5_wp
+             IF ( surf%ts(m) >  1.0E5_wp  )  surf%ts(m) =  1.0E5_wp
+
           ENDDO
        ENDIF
 
 !
-!--    If required compute q*
+!--    If required compute q* at horizontal surfaces
        IF ( humidity )  THEN
-          IF ( constant_waterflux )  THEN
+          IF ( constant_waterflux  .AND.  .NOT. surf_vertical )  THEN
 !
 !--          For a given water flux in the surface layer
-             !$OMP PARALLEL DO
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   k   = nzb_s_inner(j,i)
-                   qs(j,i) = -qsws(j,i) * drho_air_zw(k) / ( us(j,i) + 1E-30_wp )
-                ENDDO
-             ENDDO
-
-          ELSE
+             !$OMP PARALLEL DO PRIVATE( i, j, k )
+             DO  m = 1, surf%ns  
+
+                i   = surf%i(m)            
+                j   = surf%j(m)
+                k   = surf%k(m)
+                surf%qs(m) = -surf%qsws(m) * drho_air_zw(k-1) /                &
+                                               ( surf%us(m) + 1E-30_wp )
+
+             ENDDO
+
+          ELSEIF ( .NOT. surf_vertical )  THEN 
              coupled_run = ( coupling_mode == 'atmosphere_to_ocean'  .AND.     &
                              run_coupled )
 
              IF ( large_scale_forcing  .AND.  lsf_surf )  THEN
-                !$OMP PARALLEL DO
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      k = nzb_s_inner(j,i)
-                      q(k,j,i) = q_surface
-                   ENDDO
+                !$OMP PARALLEL DO PRIVATE( i, j, k )
+                DO  m = 1, surf%ns  
+
+                   i   = surf%i(m)           
+                   j   = surf%j(m)
+                   k   = surf%k(m)
+                   q(k-1,j,i) = q_surface
+                   
                 ENDDO
              ENDIF
 
-             !$OMP PARALLEL DO PRIVATE( e_s, k, z_mo )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-
-                   k   = nzb_s_inner(j,i)
-                   z_mo = zu(k+1) - zw(k)
-
-!
-!--                Assume saturation for atmosphere coupled to ocean (but not
-!--                in case of precursor runs)
-                   IF ( coupled_run )  THEN
-                      e_s = 6.1_wp * &
-                              EXP( 0.07_wp * ( MIN(pt(k,j,i),pt(k+1,j,i))      &
+!
+!--          Assume saturation for atmosphere coupled to ocean (but not
+!--          in case of precursor runs)
+             IF ( coupled_run )  THEN
+                !$OMP PARALLEL DO PRIVATE( i, j, k, e_s )
+                DO  m = 1, surf%ns   
+                   i   = surf%i(m)            
+                   j   = surf%j(m)
+                   k   = surf%k(m)
+                   e_s = 6.1_wp * &
+                              EXP( 0.07_wp * ( MIN(pt(k-1,j,i),pt(k,j,i))      &
                                                - 273.15_wp ) )
-                      q(k,j,i) = 0.622_wp * e_s / ( surface_pressure - e_s )
-                   ENDIF
-
-                   IF ( cloud_physics )  THEN
-                      qs(j,i) = kappa * ( qv1(j,i) - q(k,j,i) )                &
-                                        / ( LOG( z_mo / z0q(j,i) )             &
-                                            - psi_h( z_mo / ol(j,i) )          &
-                                            + psi_h( z0q(j,i) / ol(j,i) ) )
-
-                   ELSE
-                      qs(j,i) = kappa * ( q(k+1,j,i) - q(k,j,i) )              &
-                                        / ( LOG( z_mo / z0q(j,i) )             &
-                                            - psi_h( z_mo / ol(j,i) )          &
-                                            + psi_h( z0q(j,i) / ol(j,i) ) )
-                   ENDIF
-
+                   q(k-1,j,i) = 0.622_wp * e_s / ( surface_pressure - e_s )
                 ENDDO
+             ENDIF
+
+             IF ( cloud_physics )  THEN
+               !$OMP PARALLEL DO PRIVATE( i, j, k, z_mo )
+                DO  m = 1, surf%ns   
+
+                   i   = surf%i(m)            
+                   j   = surf%j(m)
+                   k   = surf%k(m)
+   
+                   z_mo = surf%z_mo(m)
+
+                   surf%qs(m) = kappa * ( surf%qv1(m) - q(k-1,j,i) )           &
+                                        / ( LOG( z_mo / surf%z0q(m) )          &
+                                            - psi_h( z_mo / surf%ol(m) )       &
+                                            + psi_h( surf%z0q(m) /             &
+                                                     surf%ol(m) ) )
+                ENDDO
+             ELSE
+                !$OMP PARALLEL DO PRIVATE( i, j, k, z_mo )
+                DO  m = 1, surf%ns   
+
+                   i   = surf%i(m)            
+                   j   = surf%j(m)
+                   k   = surf%k(m)
+   
+                   z_mo = surf%z_mo(m)
+
+                   surf%qs(m) = kappa * ( q(k,j,i) - q(k-1,j,i) )              &
+                                        / ( LOG( z_mo / surf%z0q(m) )          &
+                                            - psi_h( z_mo / surf%ol(m) )       &
+                                            + psi_h( surf%z0q(m) /             &
+                                                     surf%ol(m) ) )
+                ENDDO
+             ENDIF
+          ENDIF
+! 
+!--       Compute q* at vertical surfaces
+          IF ( surf_vertical )  THEN
+             !$OMP PARALLEL DO PRIVATE( i, j, k )
+             DO  m = 1, surf%ns  
+
+                i          =  surf%i(m)            
+                j          =  surf%j(m)
+                k          =  surf%k(m)
+                surf%qs(m) = -surf%qsws(m) / ( surf%us(m) + 1E-30_wp )
+
              ENDDO
           ENDIF
@@ -935,12 +1725,26 @@
 !--    If required compute s*
        IF ( passive_scalar )  THEN
-          IF ( constant_scalarflux )  THEN
-!
-!--          For a given water flux in the surface layer
-             !$OMP PARALLEL DO
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   ss(j,i) = -ssws(j,i) / ( us(j,i) + 1E-30_wp )
-                ENDDO
+!
+!--       At horizontal surfaces
+          IF ( constant_scalarflux  .AND.  .NOT. surf_vertical )  THEN
+!
+!--          For a given scalar flux in the surface layer
+             !$OMP PARALLEL DO PRIVATE( i, j, k )
+             DO  m = 1, surf%ns  
+                i   = surf%i(m)            
+                j   = surf%j(m)
+                k   = surf%k(m)
+                surf%ss(m) = -surf%ssws(m) / ( surf%us(m) + 1E-30_wp )
+             ENDDO
+          ENDIF
+!
+!--       At vertical surfaces
+          IF ( surf_vertical )  THEN
+             !$OMP PARALLEL DO PRIVATE( i, j, k )
+             DO  m = 1, surf%ns  
+                i          =  surf%i(m)            
+                j          =  surf%j(m)
+                k          =  surf%k(m)
+                surf%ss(m) = -surf%ssws(m) / ( surf%us(m) + 1E-30_wp )
              ENDDO
           ENDIF
@@ -950,24 +1754,24 @@
 !
 !--    If required compute qr* and nr*
-       IF ( cloud_physics  .AND.  microphysics_seifert )   &
-       THEN
-
-          !$OMP PARALLEL DO PRIVATE( k, z_mo )
-          DO  i = nxlg, nxrg
-             DO  j = nysg, nyng
-
-                k   = nzb_s_inner(j,i)
-                z_mo = zu(k+1) - zw(k)
-
-                qrs(j,i) = kappa * ( qr(k+1,j,i) - qr(k,j,i) )              &
-                                 / ( LOG( z_mo / z0q(j,i) )                 &
-                                     - psi_h( z_mo / ol(j,i) )              &
-                                     + psi_h( z0q(j,i) / ol(j,i) ) )
-
-                nrs(j,i) = kappa * ( nr(k+1,j,i) - nr(k,j,i) )              &
-                                 / ( LOG( z_mo / z0q(j,i) )                 &
-                                     - psi_h( z_mo / ol(j,i) )              &
-                                     + psi_h( z0q(j,i) / ol(j,i) ) )
-             ENDDO
+       IF ( cloud_physics  .AND.  microphysics_seifert  .AND.                  &
+            .NOT. surf_vertical )  THEN
+          !$OMP PARALLEL DO PRIVATE( i, j, k, z_mo )
+          DO  m = 1, surf%ns    
+
+             i    = surf%i(m)            
+             j    = surf%j(m)
+             k    = surf%k(m)
+
+             z_mo = surf%z_mo(m)
+
+             surf%qrs(m) = kappa * ( qr(k,j,i) - qr(k-1,j,i) )                 &
+                                 / ( LOG( z_mo / surf%z0q(m) )                 &
+                                 - psi_h( z_mo / surf%ol(m) )                  &
+                                 + psi_h( surf%z0q(m) / surf%ol(m) ) )
+
+             surf%nrs(m) = kappa * ( nr(k,j,i) - nr(k-1,j,i) )                 &
+                                 / ( LOG( z_mo / surf%z0q(m) )                 &
+                                 - psi_h( z_mo / surf%ol(m) )                  &
+                                 + psi_h( surf%z0q(m) / surf%ol(m) ) )
           ENDDO
 
@@ -984,136 +1788,288 @@
        IMPLICIT NONE
 
-       REAL(wp) :: ol_mid !< Grid-interpolated L
-
-!
-!--    Compute u'w' for the total model domain.
-!--    First compute the corresponding component of u* and square it.
-       !$OMP PARALLEL DO PRIVATE( k, ol_mid, z_mo )
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-
-             k   = nzb_u_inner(j,i)
-             z_mo = zu(k+1) - zw(k)
-!
-!--          Compute bulk Obukhov length for this point
-             ol_mid = 0.5_wp * ( ol(j,i-1) + ol(j,i) )
-
-             IF ( ol_mid == 0.0_wp )  THEN
-                ol_mid = MIN(ol(j,i-1), ol(j,i))
+       INTEGER(iwp)  ::  m       !< loop variable over all horizontal surf elements 
+
+       REAL(wp)                            ::  dum     !< dummy to precalculate logarithm
+       REAL(wp)                            ::  flag_u  !< flag indicating u-grid, used for calculation of horizontal momentum fluxes at vertical surfaces
+       REAL(wp)                            ::  flag_v  !< flag indicating v-grid, used for calculation of horizontal momentum fluxes at vertical surfaces
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  u_i     !< u-component interpolated onto scalar grid point, required for momentum fluxes at vertical surfaces 
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  v_i     !< v-component interpolated onto scalar grid point, required for momentum fluxes at vertical surfaces 
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  w_i     !< w-component interpolated onto scalar grid point, required for momentum fluxes at vertical surfaces 
+
+!
+!--    Calcuate surface fluxes at horizontal walls
+       IF ( .NOT. surf_vertical )  THEN
+!
+!--       Compute u'w' for the total model domain at upward-facing surfaces.
+!--       First compute the corresponding component of u* and square it.
+          IF ( .NOT. downward )  THEN
+             !$OMP PARALLEL DO PRIVATE( i, j, k, z_mo )
+             DO  m = 1, surf%ns  
+   
+                i = surf%i(m)            
+                j = surf%j(m)
+                k = surf%k(m)
+
+                z_mo = surf%z_mo(m)
+
+                surf%usws(m) = kappa * ( u(k,j,i) - u(k-1,j,i) )               &
+                              / ( LOG( z_mo / surf%z0(m) )                     &
+                                  - psi_m( z_mo / surf%ol(m) )                 &
+                                  + psi_m( surf%z0(m) / surf%ol(m) ) )
+!
+!--             Please note, the computation of usws is not fully accurate. Actually 
+!--             a further interpolation of us onto the u-grid, where usws is defined, 
+!--             is required. However, this is not done as this would require several
+!--             data transfers between 2D-grid and the surf-type. 
+!--             The impact of the missing interpolation is negligible as several 
+!--             tests had shown. 
+!--             Same also for ol.  
+                surf%usws(m) = -surf%usws(m) * surf%us(m) * rho_air_zw(k-1)
+
+             ENDDO
+!
+!--       At downward-facing surfaces
+          ELSE
+             !$OMP PARALLEL DO PRIVATE( i, j, k, z_mo )
+             DO  m = 1, surf%ns  
+   
+                i = surf%i(m)            
+                j = surf%j(m)
+                k = surf%k(m)
+
+                z_mo = surf%z_mo(m)
+
+                surf%usws(m) = kappa * u(k,j,i) / LOG( z_mo / surf%z0(m) )
+!
+!--        To Do: Is the sign correct???
+                surf%usws(m) = surf%usws(m) * surf%us(m) * rho_air_zw(k)
+
+             ENDDO     
+          ENDIF
+
+!
+!--       Compute v'w' for the total model domain.
+!--       First compute the corresponding component of u* and square it.
+!--       Upward-facing surfaces
+          IF ( .NOT. downward )  THEN
+             !$OMP PARALLEL DO PRIVATE( i, j, k, z_mo )
+             DO  m = 1, surf%ns  
+                i = surf%i(m)            
+                j = surf%j(m)
+                k = surf%k(m)
+
+                z_mo = surf%z_mo(m)
+
+                surf%vsws(m) = kappa * ( v(k,j,i) - v(k-1,j,i) )               &
+                           / ( LOG( z_mo / surf%z0(m) )                        &
+                               - psi_m( z_mo / surf%ol(m) )                    &
+                               + psi_m( surf%z0(m) / surf%ol(m) ) )
+!
+!--             Please note, the computation of vsws is not fully accurate. Actually 
+!--             a further interpolation of us onto the v-grid, where vsws is defined, 
+!--             is required. However, this is not done as this would require several
+!--             data transfers between 2D-grid and the surf-type. 
+!--             The impact of the missing interpolation is negligible as several 
+!--             tests had shown. 
+!--             Same also for ol.  
+                surf%vsws(m) = -surf%vsws(m) * surf%us(m) * rho_air_zw(k-1)
+             ENDDO
+!
+!--       Downward-facing surfaces
+          ELSE
+             !$OMP PARALLEL DO PRIVATE( i, j, k, z_mo )
+             DO  m = 1, surf%ns  
+                i = surf%i(m)            
+                j = surf%j(m)
+                k = surf%k(m)
+
+                z_mo = surf%z_mo(m)
+
+                surf%vsws(m) = kappa * v(k,j,i) / LOG( z_mo / surf%z0(m) )
+ 
+                surf%vsws(m) = surf%vsws(m) * surf%us(m) * rho_air_zw(k)
+             ENDDO
+          ENDIF
+!
+!--       Compute the vertical kinematic heat flux
+          IF (  .NOT.  constant_heatflux  .AND.  ( simulated_time <=           &
+               skip_time_do_lsm  .OR.  .NOT.  land_surface )  .AND.            &
+               .NOT.  urban_surface  .AND.  .NOT. downward )  THEN
+             !$OMP PARALLEL DO PRIVATE( i, j, k )
+             DO  m = 1, surf%ns 
+                i    = surf%i(m)            
+                j    = surf%j(m)
+                k    = surf%k(m)
+                surf%shf(m) = -surf%ts(m) * surf%us(m) * rho_air_zw(k-1)
+             ENDDO
+          ENDIF
+!
+!--       Compute the vertical water flux
+          IF (  .NOT.  constant_waterflux  .AND.  humidity  .AND.              &
+                ( simulated_time <= skip_time_do_lsm                           &
+               .OR.  .NOT.  land_surface )  .AND.  .NOT. downward )  THEN
+             !$OMP PARALLEL DO PRIVATE( i, j, k )
+             DO  m = 1, surf%ns 
+                i    = surf%i(m)            
+                j    = surf%j(m)
+                k    = surf%k(m)
+                surf%qsws(m) = -surf%qs(m) * surf%us(m) * rho_air_zw(k-1)
+             ENDDO
+          ENDIF
+!
+!--       Compute the vertical scalar flux
+          IF (  .NOT.  constant_scalarflux  .AND.  passive_scalar  .AND.       &
+                .NOT.  downward )  THEN
+             !$OMP PARALLEL DO PRIVATE( i, j, k )
+             DO  m = 1, surf%ns   
+
+                i    = surf%i(m)            
+                j    = surf%j(m)
+                k    = surf%k(m)
+                surf%ssws(m) = -surf%ss(m) * surf%us(m)
+
+             ENDDO
+          ENDIF       
+!
+!--       Compute (turbulent) fluxes of rain water content and rain drop conc.
+          IF ( cloud_physics  .AND.  microphysics_seifert  .AND.              &
+               .NOT. downward)  THEN
+             !$OMP PARALLEL DO PRIVATE( i, j, k )
+             DO  m = 1, surf%ns   
+
+                i    = surf%i(m)            
+                j    = surf%j(m)
+                k    = surf%k(m)
+
+                surf%qrsws(m) = -surf%qrs(m) * surf%us(m)
+                surf%nrsws(m) = -surf%nrs(m) * surf%us(m)
+             ENDDO
+          ENDIF
+
+!
+!--       Bottom boundary condition for the TKE. 
+          IF ( ibc_e_b == 2 )  THEN
+             !$OMP PARALLEL DO PRIVATE( i, j, k )
+             DO  m = 1, surf%ns   
+
+                i    = surf%i(m)            
+                j    = surf%j(m)
+                k    = surf%k(m)
+
+                e(k,j,i) = ( surf%us(m) / 0.1_wp )**2
+!
+!--             As a test: cm = 0.4
+!               e(k,j,i) = ( us(j,i) / 0.4_wp )**2
+                e(k-1,j,i)   = e(k,j,i)
+
+             ENDDO
+          ENDIF
+!
+!--    Calcuate surface fluxes at vertical surfaces. No stability is considered. 
+       ELSE
+!
+!--       Compute usvs l={0,1} and vsus l={2,3}
+          IF ( mom_uv )  THEN
+!
+!--          Generalize computation by introducing flags. At north- and south-
+!--          facing surfaces u-component is used, at east- and west-facing
+!--          surfaces v-component is used.
+             flag_u = MERGE( 1.0_wp, 0.0_wp, l == 0  .OR.  l == 1 )   
+             flag_v = MERGE( 1.0_wp, 0.0_wp, l == 2  .OR.  l == 3 )   
+             !$OMP PARALLEL  DO PRIVATE( i, j, k, z_mo )
+             DO  m = 1, surf%ns  
+                i = surf%i(m)            
+                j = surf%j(m)
+                k = surf%k(m)
+
+                z_mo = surf%z_mo(m)
+
+                surf%mom_flux_uv(m) = kappa *                                  &
+                                ( flag_u * u(k,j,i) + flag_v * v(k,j,i) )  /   &
+                                                        LOG( z_mo / surf%z0(m) )
+
+               surf%mom_flux_uv(m) =                                           &
+                                    - surf%mom_flux_uv(m) * surf%us(m)
+             ENDDO
+          ENDIF
+!
+!--       Compute wsus l={0,1} and wsvs l={2,3}
+          IF ( mom_w )  THEN
+             !$OMP PARALLEL  DO PRIVATE( i, j, k, z_mo )
+             DO  m = 1, surf%ns  
+                i = surf%i(m)            
+                j = surf%j(m)
+                k = surf%k(m)
+
+                z_mo = surf%z_mo(m)
+
+                surf%mom_flux_w(m) = kappa * w(k,j,i) / LOG( z_mo / surf%z0(m) )
+
+                surf%mom_flux_w(m) =                                           &
+                                     - surf%mom_flux_w(m) * surf%us(m)
+             ENDDO
+          ENDIF
+!
+!--       Compute momentum fluxes used for subgrid-scale TKE production at 
+!--       vertical surfaces. In constrast to the calculated momentum fluxes at 
+!--       vertical surfaces before, which are defined on the u/v/w-grid, 
+!--       respectively), the TKE fluxes are defined at the scalar grid. 
+!--       
+          IF ( mom_tke )  THEN
+!
+!--          Precalculate velocity components at scalar grid point. 
+             ALLOCATE( u_i(1:surf%ns) )
+             ALLOCATE( v_i(1:surf%ns) )
+             ALLOCATE( w_i(1:surf%ns) )
+
+             IF ( l == 0  .OR.  l == 1 )  THEN
+                !$OMP PARALLEL DO PRIVATE( i, j, k )
+                DO  m = 1, surf%ns  
+                   i = surf%i(m)            
+                   j = surf%j(m)
+                   k = surf%k(m)
+
+                   u_i(m) = 0.5_wp * ( u(k,j,i) + u(k,j,i+1) )
+                   v_i(m) = 0.0_wp
+                   w_i(m) = 0.5_wp * ( w(k,j,i) + w(k-1,j,i) )
+                ENDDO
+             ELSE
+                !$OMP PARALLEL DO PRIVATE( i, j, k )
+                DO  m = 1, surf%ns  
+                   i = surf%i(m)            
+                   j = surf%j(m)
+                   k = surf%k(m)
+
+                   u_i(m) = 0.0_wp
+                   v_i(m) = 0.5_wp * ( v(k,j,i) + v(k,j+1,i) )
+                   w_i(m) = 0.5_wp * ( w(k,j,i) + w(k-1,j,i) )
+                ENDDO
              ENDIF
 
-             usws(j,i) = kappa * ( u(k+1,j,i) - u(k,j,i) )                     &
-                                 / ( LOG( z_mo / z0(j,i) )                     &
-                                     - psi_m( z_mo / ol_mid )                  &
-                                     + psi_m( z0(j,i) / ol_mid ) )
-
-             usws(j,i) = -usws(j,i) * 0.5_wp * ( us(j,i-1) + us(j,i) )         &
-                                    * rho_air_zw(k)
-          ENDDO
-       ENDDO
-
-!
-!--    Compute v'w' for the total model domain.
-!--    First compute the corresponding component of u* and square it.
-       !$OMP PARALLEL DO PRIVATE( k, ol_mid, z_mo )
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-
-             k   = nzb_v_inner(j,i)
-             z_mo = zu(k+1) - zw(k)
-!
-!--          Compute bulk Obukhov length for this point
-             ol_mid = 0.5_wp * ( ol(j-1,i) + ol(j,i) )
-
-             IF ( ol_mid == 0.0_wp )  THEN
-                ol_mid = MIN(ol(j-1,i), ol(j-1,i))
-             ENDIF
-
-             vsws(j,i) = kappa * ( v(k+1,j,i) - v(k,j,i) )                     &
-                                 / ( LOG( z_mo / z0(j,i) )                     &
-                                     - psi_m( z_mo / ol_mid )                  &
-                                     + psi_m( z0(j,i) / ol_mid ) )
-
-             vsws(j,i) = -vsws(j,i) * 0.5_wp * ( us(j-1,i) + us(j,i) )         &
-                                    * rho_air_zw(k)
-
-          ENDDO
-       ENDDO
-
-!
-!--    Exchange the boundaries for the momentum fluxes (is this still required?)
-       CALL exchange_horiz_2d( usws )
-       CALL exchange_horiz_2d( vsws )
-
-!
-!--    Compute the vertical kinematic heat flux
-       IF (  .NOT.  constant_heatflux  .AND.  ( simulated_time <=            &
-            skip_time_do_lsm  .OR.  .NOT.  land_surface )  .AND.             &
-            .NOT.  urban_surface )  THEN
-          !$OMP PARALLEL DO
-          DO  i = nxlg, nxrg
-             DO  j = nysg, nyng
-                k   = nzb_s_inner(j,i)
-                shf(j,i) = -ts(j,i) * us(j,i) * rho_air_zw(k)
-             ENDDO
-          ENDDO
-
-       ENDIF
-
-!
-!--    Compute the vertical water flux
-       IF (  .NOT.  constant_waterflux  .AND.  humidity  .AND.                 &
-             ( simulated_time <= skip_time_do_lsm                              &
-            .OR.  .NOT.  land_surface ) )  THEN
-          !$OMP PARALLEL DO
-          DO  i = nxlg, nxrg
-             DO  j = nysg, nyng
-                k   = nzb_s_inner(j,i)
-                qsws(j,i) = -qs(j,i) * us(j,i) * rho_air_zw(k)
-             ENDDO
-          ENDDO
-
-       ENDIF
-       
-!
-!--    Compute the vertical scalar flux
-       IF (  .NOT.  constant_scalarflux  .AND.  passive_scalar  .AND.          &
-             ( simulated_time <= skip_time_do_lsm                              &
-            .OR.  .NOT.  land_surface ) )  THEN
-          !$OMP PARALLEL DO
-          DO  i = nxlg, nxrg
-             DO  j = nysg, nyng
-                ssws(j,i) = -ss(j,i) * us(j,i)
-             ENDDO
-          ENDDO
-
-       ENDIF       
-
-!
-!--    Compute (turbulent) fluxes of rain water content and rain drop conc.
-       IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-          !$OMP PARALLEL DO
-          DO  i = nxlg, nxrg
-             DO  j = nysg, nyng
-                qrsws(j,i) = -qrs(j,i) * us(j,i)
-                nrsws(j,i) = -nrs(j,i) * us(j,i)
-             ENDDO
-          ENDDO
-       ENDIF
-
-!
-!--    Bottom boundary condition for the TKE
-       IF ( ibc_e_b == 2 )  THEN
-          !$OMP PARALLEL DO
-          DO  i = nxlg, nxrg
-             DO  j = nysg, nyng
-                k = nzb_s_inner(j,i)
-                e(k+1,j,i) = ( us(j,i) / 0.1_wp )**2
-!
-!--             As a test: cm = 0.4
-!               e(k+1,j,i) = ( us(j,i) / 0.4_wp )**2
-                e(k,j,i)   = e(k+1,j,i)
-             ENDDO
-          ENDDO
+             !$OMP PARALLEL DO PRIVATE( i, j, k, dum, z_mo )
+             DO  m = 1, surf%ns  
+                i = surf%i(m)            
+                j = surf%j(m)
+                k = surf%k(m)
+
+                z_mo = surf%z_mo(m)
+
+                dum = kappa / LOG( z_mo / surf%z0(m) )
+!
+!--             usvs (l=0,1) and vsus (l=2,3)
+                surf%mom_flux_tke(0,m) = dum * ( u_i(m) + v_i(m) )
+!
+!--             wsvs (l=0,1) and wsus (l=2,3)
+                surf%mom_flux_tke(1,m) = dum * w_i(m)
+
+                surf%mom_flux_tke(0:1,m) =                                     &
+                               - surf%mom_flux_tke(0:1,m) * surf%us(m)
+             ENDDO
+!
+!--          Deallocate temporary arrays
+             DEALLOCATE( u_i )             
+             DEALLOCATE( v_i )  
+             DEALLOCATE( w_i )  
+          ENDIF
        ENDIF
 
Index: /palm/trunk/SOURCE/swap_timelevel.f90
===================================================================
--- /palm/trunk/SOURCE/swap_timelevel.f90	(revision 2231)
+++ /palm/trunk/SOURCE/swap_timelevel.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Adjustments to new surface concept
 ! 
 ! Former revisions:
@@ -111,5 +111,5 @@
 
     USE land_surface_model_mod,                                                &
-        ONLY: land_surface, lsm_swap_timelevel
+        ONLY: lsm_swap_timelevel
 
     USE cpulog,                                                                &
@@ -117,5 +117,5 @@
 
     USE control_parameters,                                                    &
-        ONLY:  cloud_physics, constant_diffusion, humidity,                    &
+        ONLY:  cloud_physics, constant_diffusion, humidity, land_surface,      &
                microphysics_seifert, neutral, ocean, passive_scalar,           &
                timestep_count, urban_surface
